from avatar2 import *
from avatar2.peripherals import AvatarPeripheral
from capstone import CS_MODE_THUMB

import os, struct
from time import sleep

from IPython import embed

class HelloWorldPeripheral(AvatarPeripheral):

    def hw_read(self, offset, size):         
        ret = self.hello_world[:size]
        self.hello_world = self.hello_world[size:] + self.hello_world[:size]
        print("READ")
        return ret

    def nop_write(self, offset, size, value):
        print("WRITE")
        return True    

    def __init__(self, name, address, size, **kwargs):
        AvatarPeripheral.__init__(self, name, address, size)
        
        self.hello_world='Hello World'
        
        self.read_handler[0:size] = self.hw_read 
        self.write_handler[0:size] = self.nop_write
        


avatar = Avatar(output_directory='/tmp/avatar123')
avatar.log.setLevel('DEBUG')

hw = avatar.add_memory_range(0x40004c00, 0x100, name='hello_world',
                             emulate=HelloWorldPeripheral, permissions='rw-')        

avatar.add_memory_range(0x1000, 0x1000, file='./test.raw')


qemu = avatar.add_target(QemuTarget, name='qemu1',entry_address=0x1000)
qemu.cpu_model = 'cortex-a8'

qemu.init()
qemu.cont()
qemu.wait()

